#!/usr/bin/env ruby

require 'ROOT'
include ROOT

# Writing a histogram
chfile = "test.root"
hfile = TFile.new(chfile,"RECREATE","Test histograms")

hist = TH1F.new("hist","Test",100,-5.0,5.0)

gr = ROOT::gRandom
gr.SetSeed(123456)

10000.times do
      vargauss = gr.Gaus(0.0,1.0)
      hist.Fill(vargauss)
end

hfile.Write
puts "\nOutput histograms written in file \"%s\"" % chfile

# Warning: do not try "hfile.Close"; objects must be destroyed by Ruby

# Read it again
hfile.ReOpen("READ")
histnew = hfile.Get("hist").to_TH1F
histnew.Fit("gaus")
