#!/usr/bin/env ruby

require 'ROOT'
include ROOT

app = TApplication.new("My Application",0,[])

chfile = "test.root"
outfile = TFile.new(chfile,"RECREATE","Test histograms")

hist = TH1F.new("hist","Test",100,-5.0,5.0)

gr = ROOT::gRandom
gr.SetSeed(123456)

10000.times do
      vargauss = gr.Gaus(0.0,1.0)
      hist.Fill(vargauss)
end

hist.Fit "gaus" 

outfile.Write
puts "\nOutput histograms written in file \"%s\"" % chfile

app.Run
